/*
// An example of inheritance
//
*/

#include <iostream>

using namespace std ;

// define a base class
class base_class {
  int value ; // declare private variable
public:

  base_class()
  : value(0) // calling the costructor for value
  { cout << "base_class constructor\n" ; }
  /* this is similar to
     base_class(){ value = 0 ; }
     the difference is on the order of the operatio.
     in this latter case the default costrutor for
     value  is performed and next is assigned to 0.
     using the proposed costruct the variable value
     is initialized to 0 directly. Thus is a better 
     performing design 
  */

  // a public method
  void printName(ostream & s)
  { s << "I am base class\n" ; }

  // accessor method
  int getValue() const { return value ; }
} ;

// define extend_class inherithing from base_class
class extend_class : public base_class {
public:
  extend_class()
  : base_class() // call the base_class constructor
  { cout << "extend_class constructor\n" ; }
 
  // redefine the method printName
  void printName(ostream & s)
  { s << "I am extend_class class\n" ; }
} ;

int
main() {
  base_class   bc ; // instance bc with the default constructor
  extend_class ec ; // instance ec with the default constructor
  bc . printName( cout ) ;
  ec . printName( cout ) ;
  return 0 ;
}