/*
// An example of inheritance
//
*/

#include <iostream>

using namespace std ;

typedef double valueType ;
typedef int    indexType ;

class point2d {
protected:
  valueType x, y ;
public:

  point2d() : x(0), y(0) // calling the costructor for value
  { cout << "point2d constructor\n" ; }

  point2d(valueType xx, valueType yy) : x(xx), y(yy) // calling the costructor for value
  { cout << "point2d constructor N.2\n" ; }

  ~point2d()
  { cout << "point2d destructor\n" ; }

  point2d const &
  operator = (point2d const & a) { 
    cout << "assign operator\n" ;
    x = a.x ;
    y = a.y ;
    return *this ;
  }

  valueType getX() const { return x ; }
  valueType getY() const { return y ; }
  void set( valueType x, valueType y ) {
    this -> x = x ;
    this -> y = y ;
  }

} ;

class point3d : public point2d {
  valueType z ;
public:

  point3d() : point2d(0,0), z(0) // calling the costructor for value
  { cout << "point3d constructor\n" ; }

  point3d(valueType xx, valueType yy, valueType zz)
  : point2d(xx,yy), z(zz) // calling the costructor for value
  { cout << "point3d constructor N.2\n" ; }

  ~point3d()
  { cout << "point3d destructor\n" ; }

  point3d const &
  operator = (point3d const & a) { 
    cout << "assign operator\n" ;
    x = a.x ;
    y = a.y ;
    z = a.z ;
    return *this ;
  }

  valueType getZ() const { return z ; }

  void set( valueType x, valueType y, valueType z ) {
    point2d::set(x,y) ;
    this -> z = z ;
  }
} ;


// define external operator for addition
point2d
operator + ( point2d const & a, point2d const & b)
{ cout << "perform + operator\n" ;
  return point2d( a.getX()+b.getX(), a.getY() + b.getY()) ; }
/*

 */

int
main() {
  cout << "before point2d a, b ;\n" ;
  point2d a, b, c ;
  cout << "after point2d a, b ;\n" ;
  c = a + b ;
  // this is eqauivalent to 
  
  c . operator = ( operator + (a,b) ) ;

  cout << "before to exit;\n" ;
  // the same operatio without temporary class production
  a . set( a.getX() + b.getX(), a.getY() + b.getY() ) ;
  return 0 ;
}